"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _webinyModel = require("webiny-model");

var _entityAttributes = require("./entityAttributes");

class EntityAttributesContainer extends _webinyModel.DefaultAttributesContainer {
  entity(entity, options = {}) {
    const parent = this.getParentModel();
    parent.setAttribute(this.name, new _entityAttributes.EntityAttribute(this.name, this, entity, options));
    return parent.getAttribute(this.name);
  }

  entities(entity, attribute = "") {
    const parent = this.getParentModel();
    parent.setAttribute(this.name, new _entityAttributes.EntitiesAttribute(this.name, this, entity, attribute));
    return parent.getAttribute(this.name);
  }

  model(model) {
    const parent = this.getParentModel();
    parent.setAttribute(this.name, new _entityAttributes.ModelAttribute(this.name, this, model));
    return parent.getAttribute(this.name);
  }

  models(model, keyValue = false) {
    const parent = this.getParentModel();
    parent.setAttribute(this.name, new _entityAttributes.ModelsAttribute(this.name, this, model, keyValue));
    return parent.getAttribute(this.name);
  }

}

var _default = EntityAttributesContainer;
exports.default = _default;
//# sourceMappingURL=entityAttributesContainer.js.map