"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _entity = _interopRequireDefault(require("./entity"));

class EntityCollection extends Array {
  constructor(values = []) {
    super();
    (0, _defineProperty2.default)(this, "__entityCollection", void 0);
    this.__entityCollection = {
      params: {},
      meta: {}
    };

    if (Array.isArray(values)) {
      values.map(item => this.push(item));
    }
  }

  setParams(params) {
    this.__entityCollection.params = params;
    return this;
  }

  getParams() {
    return this.__entityCollection.params;
  }

  setMeta(meta) {
    this.__entityCollection.meta = meta;
    return this;
  }

  getMeta() {
    return this.__entityCollection.meta;
  }

  async toJSON(fields) {
    const collection = this.map(async entity => {
      if (_entity.default.isEntityInstance(entity)) {
        return await entity.toJSON(fields);
      }

      return entity;
    });
    return Promise.all(collection);
  }

  setTotalCount(totalCount) {
    this.__entityCollection.meta.totalCount = totalCount;
    return this;
  }

  getTotalCount() {
    return this.__entityCollection.meta.totalCount;
  }

}

var _default = EntityCollection;
exports.default = _default;
//# sourceMappingURL=entityCollection.js.map