"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

/**
 * @private
 */
class EventHandler {
  constructor(name, callback) {
    (0, _defineProperty2.default)(this, "name", void 0);
    (0, _defineProperty2.default)(this, "callback", void 0);
    (0, _defineProperty2.default)(this, "executed", void 0);
    (0, _defineProperty2.default)(this, "once", void 0);
    this.name = name;
    this.callback = callback;
    this.executed = false;
    this.once = false;
  }

  execute(params) {
    if (this.getOnce() && this.executed) {
      return;
    }

    this.executed = true;
    return this.getCallback()(params);
  }

  getName() {
    return this.name;
  }

  getCallback() {
    return this.callback;
  }

  setOnce(flag = true) {
    this.once = flag;
    return this;
  }

  getOnce() {
    return this.once;
  }

}

var _default = EventHandler;
exports.default = _default;
//# sourceMappingURL=eventHandler.js.map